spandsp 0.0.6

t30.h
Go to the documentation of this file.
1/*
2 * SpanDSP - a series of DSP components for telephony
3 *
4 * t30.h - definitions for T.30 fax processing
5 *
6 * Written by Steve Underwood <steveu@coppice.org>
7 *
8 * Copyright (C) 2003 Steve Underwood
9 *
10 * All rights reserved.
11 *
12 * This program is free software; you can redistribute it and/or modify
13 * it under the terms of the GNU Lesser General Public License version 2.1,
14 * as published by the Free Software Foundation.
15 *
16 * This program is distributed in the hope that it will be useful,
17 * but WITHOUT ANY WARRANTY; without even the implied warranty of
18 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
19 * GNU Lesser General Public License for more details.
20 *
21 * You should have received a copy of the GNU Lesser General Public
22 * License along with this program; if not, write to the Free Software
23 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
24 */
25
26/*! \file */
27
28#if !defined(_SPANDSP_T30_H_)
29#define _SPANDSP_T30_H_
30
31/*! \page t30_page T.30 FAX protocol handling
32
33\section t30_page_sec_1 What does it do?
34 The T.30 protocol is the core protocol used for FAX transmission. This module
35 implements most of its key featrues. It does not interface to the outside work.
36 Seperate modules do that for T.38, analogue line, and other forms of FAX
37 communication.
38
39 Current features of this module include:
40
41 - FAXing to and from multi-page TIFF/F files, whose images are one of the standard
42 FAX sizes.
43 - V.27ter, V.29 and V.17 modes (2400bps, to 14,400bps).
44 - T.4 1D (MH), T.4 2D,(MR) and T.6 (MMR) compression.
45 - Error correction mode (ECM).
46 - All standard horizonal resolutions (R8, R16, 300dpi, 600dpi, 800dpi, 1200dpi).
47 - All standard vertical resolutions (standard, fine, superfine, 300dpi, 600dpi, 800dpi, 1200dpi).
48 - All standard page widths (A4, B4, A3).
49 - All standard page lengths (A4, B4, North American letter, North American legal, continuous).
50 - Monitoring and sending identifier strings (CSI, TSI, and CIG).
51 - Monitoring and sending sub-address strings (SUB).
52 - Monitoring and sending polling sub-addresses (SEP).
53 - Monitoring and sending polled sub-addresses (PSA).
54 - Monitoring and sending sender identifications (SID).
55 - Monitoring and sending passwords (PWD).
56 - Monitoring of non-standard facility frames (NSF, NSC, and NSS).
57 - Sending custom non-standard facility frames (NSF, NSC, and NSS).
58 - Analogue modem and T.38 operation.
59
60\section t30_page_sec_2 How does it work?
61
62 Some of the following is paraphrased from some notes found a while ago on the Internet.
63 I cannot remember exactly where they came from, but they are useful.
64
65\subsection t30_page_sec_2a The answer (CED) tone
66
67 The T.30 standard says an answering fax device must send CED (a 2100Hz tone) for
68 approximately 3 seconds before sending the first handshake message. Some machines
69 send an 1100Hz or 1850Hz tone, and some send no tone at all. In fact, this answer
70 tone is so unpredictable, it cannot really be used. It should, however, always be
71 generated according to the specification.
72
73\subsection t30_page_sec_2b Common Timing Deviations
74
75 The T.30 spec. specifies a number of time-outs. For example, after dialing a number,
76 a calling fax system should listen for a response for 35 seconds before giving up.
77 These time-out periods are as follows:
78
79 - T1 - 35+-5s: the maximum time for which two fax system will attempt to identify each other
80 - T2 - 6+-1s: a time-out used to start the sequence for changing transmit parameters
81 - T3 - 10+-5s: a time-out used in handling operator interrupts
82 - T5 - 60+-5s: a time-out used in error correction mode
83
84 These time-outs are sometimes misinterpreted. In addition, they are routinely
85 ignored, sometimes with good reason. For example, after placing a call, the
86 calling fax system is supposed to wait for 35 seconds before giving up. If the
87 answering unit does not answer on the first ring or if a voice answering machine
88 is connected to the line, or if there are many delays through the network,
89 the delay before answer can be much longer than 35 seconds.
90
91 Fax units that support error correction mode (ECM) can respond to a post-image
92 handshake message with a receiver not ready (RNR) message. The calling unit then
93 queries the receiving fax unit with a receiver ready (RR) message. If the
94 answering unit is still busy (printing for example), it will repeat the RNR
95 message. According to the T.30 standard, this sequence (RR/RNR RR/RNR) can be
96 repeated for up to the end of T5 (60+-5s). However, many fax systems
97 ignore the time-out and will continue the sequence indefinitely, unless the user
98 manually overrides.
99
100 All the time-outs are subject to alteration, and sometimes misuse. Good T.30
101 implementations must do the right thing, and tolerate others doing the wrong thing.
102
103\subsection t30_page_sec_2c Variations in the inter-carrier gap
104
105 T.30 specifies 75+-20ms of silence between signals using different modulation
106 schemes. Examples are between the end of a DCS signal and the start of a TCF signal,
107 and between the end of an image and the start of a post-image signal. Many fax systems
108 violate this requirement, especially for the silent period between DCS and TCF.
109 This may be stretched to well over 100ms. If this period is too long, it can interfere with
110 handshake signal error recovery, should a packet be corrupted on the line. Systems
111 should ensure they stay within the prescribed T.30 limits, and be tolerant of others
112 being out of spec..
113
114\subsection t30_page_sec_2d Other timing variations
115
116 Testing is required to determine the ability of a fax system to handle
117 variations in the duration of pauses between unacknowledged handshake message
118 repetitions, and also in the pauses between the receipt of a handshake command and
119 the start of a response to that command. In order to reduce the total
120 transmission time, many fax systems start sending a response message before the
121 end of the command has been received.
122
123\subsection t30_page_sec_2e Other deviations from the T.30 standard
124
125 There are many other commonly encountered variations between machines, including:
126
127 - frame sequence deviations
128 - preamble and flag sequence variations
129 - improper EOM usage
130 - unusual data rate fallback sequences
131 - common training pattern detection algorithms
132 - image transmission deviations
133 - use of the talker echo protect tone
134 - image padding and short lines
135 - RTP/RTN handshake message usage
136 - long duration lines
137 - nonstandard disconnect sequences
138 - DCN usage
139*/
140
141/*! The maximum length of a DIS, DTC or DCS frame */
142#define T30_MAX_DIS_DTC_DCS_LEN 22
143/*! The maximum length of the body of an ident string */
144#define T30_MAX_IDENT_LEN 20
145/*! The maximum length of the user string to insert in page headers */
146#define T30_MAX_PAGE_HEADER_INFO 50
147
148 typedef struct t30_state_s t30_state_t;
149
150/*!
151 T.30 phase B callback handler. This handler can be used to process addition
152 information available in some FAX calls, such as passwords. The callback handler
153 can access whatever additional information might have been received, using
154 t30_get_received_info().
155 \brief T.30 phase B callback handler.
156 \param s The T.30 context.
157 \param user_data An opaque pointer.
158 \param result The phase B event code.
159 \return The new status. Normally, T30_ERR_OK is returned.
160*/
161 typedef int (t30_phase_b_handler_t)(t30_state_t *s, void *user_data, int result);
162
163/*!
164 T.30 phase D callback handler.
165 \brief T.30 phase D callback handler.
166 \param s The T.30 context.
167 \param user_data An opaque pointer.
168 \param result The phase D event code.
169 \return The new status. Normally, T30_ERR_OK is returned.
170*/
171 typedef int (t30_phase_d_handler_t)(t30_state_t *s, void *user_data, int result);
172
173/*!
174 T.30 phase E callback handler.
175 \brief T.30 phase E callback handler.
176 \param s The T.30 context.
177 \param user_data An opaque pointer.
178 \param completion_code The phase E completion code.
179*/
180 typedef void (t30_phase_e_handler_t)(t30_state_t *s, void *user_data, int completion_code);
181
182/*!
183 T.30 real time frame handler.
184 \brief T.30 real time frame handler.
185 \param s The T.30 context.
186 \param user_data An opaque pointer.
187 \param direction TRUE for incoming, FALSE for outgoing.
188 \param msg The HDLC message.
189 \param len The length of the message.
190*/
191 typedef void (t30_real_time_frame_handler_t)(t30_state_t *s,
192 void *user_data,
193 int direction,
194 const uint8_t msg[],
195 int len);
196
197/*!
198 T.30 document handler.
199 \brief T.30 document handler.
200 \param s The T.30 context.
201 \param user_data An opaque pointer.
202 \param result The document event code.
203*/
204 typedef int (t30_document_handler_t)(t30_state_t *s, void *user_data, int status);
205
206/*!
207 T.30 set a receive or transmit type handler.
208 \brief T.30 set a receive or transmit type handler.
209 \param user_data An opaque pointer.
210 \param type The modem, tone or silence to be sent or received.
211 \param bit_rate The bit rate of the modem to be sent or received.
212 \param short_train TRUE if the short training sequence should be used (where one exists).
213 \param use_hdlc FALSE for bit stream, TRUE for HDLC framing.
214*/
215 typedef void (t30_set_handler_t)(void *user_data, int type, int bit_rate, int short_train, int use_hdlc);
216
217/*!
218 T.30 send HDLC handler.
219 \brief T.30 send HDLC handler.
220 \param user_data An opaque pointer.
221 \param msg The HDLC message.
222 \param len The length of the message.
223*/
224 typedef void (t30_send_hdlc_handler_t)(void *user_data, const uint8_t msg[], int len);
225
226/*!
227 T.30 protocol completion codes, at phase E.
228*/
229 enum
230{
231 T30_ERR_OK = 0, /*! OK */
232
233 /* Link problems */
234 T30_ERR_CEDTONE, /*! The CED tone exceeded 5s */
235 T30_ERR_T0_EXPIRED, /*! Timed out waiting for initial communication */
236 T30_ERR_T1_EXPIRED, /*! Timed out waiting for the first message */
237 T30_ERR_T3_EXPIRED, /*! Timed out waiting for procedural interrupt */
238 T30_ERR_HDLC_CARRIER, /*! The HDLC carrier did not stop in a timely manner */
239 T30_ERR_CANNOT_TRAIN, /*! Failed to train with any of the compatible modems */
240 T30_ERR_OPER_INT_FAIL, /*! Operator intervention failed */
241 T30_ERR_INCOMPATIBLE, /*! Far end is not compatible */
242 T30_ERR_RX_INCAPABLE, /*! Far end is not able to receive */
243 T30_ERR_TX_INCAPABLE, /*! Far end is not able to transmit */
244 T30_ERR_NORESSUPPORT, /*! Far end cannot receive at the resolution of the image */
245 T30_ERR_NOSIZESUPPORT, /*! Far end cannot receive at the size of image */
246 T30_ERR_UNEXPECTED, /*! Unexpected message received */
247
248 /* Phase E status values returned to a transmitter */
249 T30_ERR_TX_BADDCS, /*! Received bad response to DCS or training */
250 T30_ERR_TX_BADPG, /*! Received a DCN from remote after sending a page */
251 T30_ERR_TX_ECMPHD, /*! Invalid ECM response received from receiver */
252 T30_ERR_TX_GOTDCN, /*! Received a DCN while waiting for a DIS */
253 T30_ERR_TX_INVALRSP, /*! Invalid response after sending a page */
254 T30_ERR_TX_NODIS, /*! Received other than DIS while waiting for DIS */
255 T30_ERR_TX_PHBDEAD, /*! Received no response to DCS, training or TCF */
256 T30_ERR_TX_PHDDEAD, /*! No response after sending a page */
257 T30_ERR_TX_T5EXP, /*! Timed out waiting for receiver ready (ECM mode) */
258
259 /* Phase E status values returned to a receiver */
260 T30_ERR_RX_ECMPHD, /*! Invalid ECM response received from transmitter */
261 T30_ERR_RX_GOTDCS, /*! DCS received while waiting for DTC */
262 T30_ERR_RX_INVALCMD, /*! Unexpected command after page received */
263 T30_ERR_RX_NOCARRIER, /*! Carrier lost during fax receive */
264 T30_ERR_RX_NOEOL, /*! Timed out while waiting for EOL (end of line) */
265 T30_ERR_RX_NOFAX, /*! Timed out while waiting for first line */
266 T30_ERR_RX_T2EXPDCN, /*! Timer T2 expired while waiting for DCN */
267 T30_ERR_RX_T2EXPD, /*! Timer T2 expired while waiting for phase D */
268 T30_ERR_RX_T2EXPFAX, /*! Timer T2 expired while waiting for fax page */
269 T30_ERR_RX_T2EXPMPS, /*! Timer T2 expired while waiting for next fax page */
270 T30_ERR_RX_T2EXPRR, /*! Timer T2 expired while waiting for RR command */
271 T30_ERR_RX_T2EXP, /*! Timer T2 expired while waiting for NSS, DCS or MCF */
272 T30_ERR_RX_DCNWHY, /*! Unexpected DCN while waiting for DCS or DIS */
273 T30_ERR_RX_DCNDATA, /*! Unexpected DCN while waiting for image data */
274 T30_ERR_RX_DCNFAX, /*! Unexpected DCN while waiting for EOM, EOP or MPS */
275 T30_ERR_RX_DCNPHD, /*! Unexpected DCN after EOM or MPS sequence */
276 T30_ERR_RX_DCNRRD, /*! Unexpected DCN after RR/RNR sequence */
277 T30_ERR_RX_DCNNORTN, /*! Unexpected DCN after requested retransmission */
278
279 /* TIFF file problems */
280 T30_ERR_FILEERROR, /*! TIFF/F file cannot be opened */
281 T30_ERR_NOPAGE, /*! TIFF/F page not found */
282 T30_ERR_BADTIFF, /*! TIFF/F format is not compatible */
283 T30_ERR_BADPAGE, /*! TIFF/F page number tag missing */
284 T30_ERR_BADTAG, /*! Incorrect values for TIFF/F tags */
285 T30_ERR_BADTIFFHDR, /*! Bad TIFF/F header - incorrect values in fields */
286 T30_ERR_NOMEM, /*! Cannot allocate memory for more pages */
287
288 /* General problems */
289 T30_ERR_RETRYDCN, /*! Disconnected after permitted retries */
290 T30_ERR_CALLDROPPED, /*! The call dropped prematurely */
291
292 /* Feature negotiation issues */
293 T30_ERR_NOPOLL, /*! Poll not accepted */
294 T30_ERR_IDENT_UNACCEPTABLE, /*! Far end's ident is not acceptable */
295 T30_ERR_SUB_UNACCEPTABLE, /*! Far end's sub-address is not acceptable */
296 T30_ERR_SEP_UNACCEPTABLE, /*! Far end's selective polling address is not acceptable */
297 T30_ERR_PSA_UNACCEPTABLE, /*! Far end's polled sub-address is not acceptable */
298 T30_ERR_SID_UNACCEPTABLE, /*! Far end's sender identification is not acceptable */
299 T30_ERR_PWD_UNACCEPTABLE, /*! Far end's password is not acceptable */
300 T30_ERR_TSA_UNACCEPTABLE, /*! Far end's transmitting subscriber internet address is not acceptable */
301 T30_ERR_IRA_UNACCEPTABLE, /*! Far end's internet routing address is not acceptable */
302 T30_ERR_CIA_UNACCEPTABLE, /*! Far end's calling subscriber internet address is not acceptable */
303 T30_ERR_ISP_UNACCEPTABLE, /*! Far end's internet selective polling address is not acceptable */
304 T30_ERR_CSA_UNACCEPTABLE /*! Far end's called subscriber internet address is not acceptable */
305};
306
307/*!
308 I/O modes for the T.30 protocol.
309 These are allocated such that the lower 4 bits represents the variant of the modem - e.g. the
310 particular bit rate selected.
311*/
312 enum
313{
314 T30_MODEM_NONE = 0,
315 T30_MODEM_PAUSE,
316 T30_MODEM_CED,
317 T30_MODEM_CNG,
318 T30_MODEM_V21,
319 T30_MODEM_V27TER,
320 T30_MODEM_V29,
321 T30_MODEM_V17,
322 T30_MODEM_V34HDX,
323 T30_MODEM_DONE
324};
325
326 enum
327{
328 T30_FRONT_END_SEND_STEP_COMPLETE = 0,
329 /*! The current receive has completed. This is only needed to report an
330 unexpected end of the receive operation, as might happen with T.38
331 dying. */
332 T30_FRONT_END_RECEIVE_COMPLETE,
333 T30_FRONT_END_SIGNAL_PRESENT,
334 T30_FRONT_END_SIGNAL_ABSENT,
335 T30_FRONT_END_CED_PRESENT,
336 T30_FRONT_END_CNG_PRESENT
337};
338
339 enum
340{
341 /*! Support the V.27ter modem (2400, and 4800bps) for image transfer. */
342 T30_SUPPORT_V27TER = 0x01,
343 /*! Support the V.29 modem (9600, and 7200bps) for image transfer. */
344 T30_SUPPORT_V29 = 0x02,
345 /*! Support the V.17 modem (14400, 12000, 9600 and 7200bps) for image transfer. */
346 T30_SUPPORT_V17 = 0x04,
347 /*! Support the V.34 modem (up to 33,600bps) for image transfer. */
348 T30_SUPPORT_V34HDX = 0x08,
349 /*! Support the Internet aware FAX mode (no bit rate limit) for image transfer. */
350 T30_SUPPORT_IAF = 0x10
351};
352
353 enum
354{
355 /*! No compression */
356 T30_SUPPORT_NO_COMPRESSION = 0x01,
357 /*! T.1 1D compression */
358 T30_SUPPORT_T4_1D_COMPRESSION = 0x02,
359 /*! T.4 2D compression */
360 T30_SUPPORT_T4_2D_COMPRESSION = 0x04,
361 /*! T.6 2D compression */
362 T30_SUPPORT_T6_COMPRESSION = 0x08,
363 /*! T.85 monochrome JBIG compression, with fixed L0 */
364 T30_SUPPORT_T85_COMPRESSION = 0x10,
365 /*! T.85 monochrome JBIG compression, with variable L0 */
366 T30_SUPPORT_T85_L0_COMPRESSION = 0x20,
367 /*! T.43 colour JBIG compression */
368 T30_SUPPORT_T43_COMPRESSION = 0x40,
369 /*! T.45 run length colour compression */
370 T30_SUPPORT_T45_COMPRESSION = 0x80,
371 /*! T.81 + T.30 Annex E colour JPEG compression */
372 T30_SUPPORT_T81_COMPRESSION = 0x100,
373 /*! T.81 + T.30 Annex K colour sYCC-JPEG compression */
374 T30_SUPPORT_SYCC_T81_COMPRESSION = 0x200,
375 /*! T.88 monochrome JBIG2 compression */
376 T30_SUPPORT_T88_COMPRESSION = 0x400
377};
378
379 enum
380{
381 /*! Support standard FAX Y-resolution 98/100dpi */
382 T30_SUPPORT_STANDARD_RESOLUTION = 0x01,
383 /*! Support fine FAX Y-resolution 196/200dpi */
384 T30_SUPPORT_FINE_RESOLUTION = 0x02,
385 /*! Support super-fine FAX Y-resolution 392/400dpi */
386 T30_SUPPORT_SUPERFINE_RESOLUTION = 0x04,
387
388 /*! Support half FAX X-resolution 100/102dpi */
389 T30_SUPPORT_R4_RESOLUTION = 0x10000,
390 /*! Support standard FAX X-resolution 200/204dpi */
391 T30_SUPPORT_R8_RESOLUTION = 0x20000,
392 /*! Support double FAX X-resolution 400dpi */
393 T30_SUPPORT_R16_RESOLUTION = 0x40000,
394
395 /*! Support 300dpi x 300 dpi */
396 T30_SUPPORT_300_300_RESOLUTION = 0x100000,
397 /*! Support 400dpi x 400 dpi */
398 T30_SUPPORT_400_400_RESOLUTION = 0x200000,
399 /*! Support 600dpi x 600 dpi */
400 T30_SUPPORT_600_600_RESOLUTION = 0x400000,
401 /*! Support 1200dpi x 1200 dpi */
402 T30_SUPPORT_1200_1200_RESOLUTION = 0x800000,
403 /*! Support 300dpi x 600 dpi */
404 T30_SUPPORT_300_600_RESOLUTION = 0x1000000,
405 /*! Support 400dpi x 800 dpi */
406 T30_SUPPORT_400_800_RESOLUTION = 0x2000000,
407 /*! Support 600dpi x 1200 dpi */
408 T30_SUPPORT_600_1200_RESOLUTION = 0x4000000
409};
410
411 enum
412{
413 T30_SUPPORT_215MM_WIDTH = 0x01,
414 T30_SUPPORT_255MM_WIDTH = 0x02,
415 T30_SUPPORT_303MM_WIDTH = 0x04,
416
417 T30_SUPPORT_UNLIMITED_LENGTH = 0x10000,
418 T30_SUPPORT_A4_LENGTH = 0x20000,
419 T30_SUPPORT_B4_LENGTH = 0x40000,
420 T30_SUPPORT_US_LETTER_LENGTH = 0x80000,
421 T30_SUPPORT_US_LEGAL_LENGTH = 0x100000
422};
423
424 enum
425{
426 /*! Enable support of identification, through the SID and/or PWD frames. */
427 T30_SUPPORT_IDENTIFICATION = 0x01,
428 /*! Enable support of selective polling, through the SEP frame. */
429 T30_SUPPORT_SELECTIVE_POLLING = 0x02,
430 /*! Enable support of polling sub-addressing, through the PSA frame. */
431 T30_SUPPORT_POLLED_SUB_ADDRESSING = 0x04,
432 /*! Enable support of multiple selective polling, through repeated used of the SEP and PSA frames. */
433 T30_SUPPORT_MULTIPLE_SELECTIVE_POLLING = 0x08,
434 /*! Enable support of sub-addressing, through the SUB frame. */
435 T30_SUPPORT_SUB_ADDRESSING = 0x10,
436 /*! Enable support of transmitting subscriber internet address, through the TSA frame. */
437 T30_SUPPORT_TRANSMITTING_SUBSCRIBER_INTERNET_ADDRESS = 0x20,
438 /*! Enable support of internet routing address, through the IRA frame. */
439 T30_SUPPORT_INTERNET_ROUTING_ADDRESS = 0x40,
440 /*! Enable support of calling subscriber internet address, through the CIA frame. */
441 T30_SUPPORT_CALLING_SUBSCRIBER_INTERNET_ADDRESS = 0x80,
442 /*! Enable support of internet selective polling address, through the ISP frame. */
443 T30_SUPPORT_INTERNET_SELECTIVE_POLLING_ADDRESS = 0x100,
444 /*! Enable support of called subscriber internet address, through the CSA frame. */
445 T30_SUPPORT_CALLED_SUBSCRIBER_INTERNET_ADDRESS = 0x200,
446 /*! Enable support of the field not valid (FNV) frame. */
447 T30_SUPPORT_FIELD_NOT_VALID = 0x400,
448 /*! Enable support of the command repeat (CRP) frame. */
449 T30_SUPPORT_COMMAND_REPEAT = 0x800
450};
451
452 enum
453{
454 T30_IAF_MODE_T37 = 0x01,
455 T30_IAF_MODE_T38 = 0x02,
456 T30_IAF_MODE_FLOW_CONTROL = 0x04,
457 /*! Continuous flow mode means data is sent as fast as possible, usually across
458 the Internet, where speed is not constrained by a PSTN modem. */
459 T30_IAF_MODE_CONTINUOUS_FLOW = 0x08,
460 /*! No TCF means TCF is not exchanged. The end points must sort out usable speed
461 issues locally. */
462 T30_IAF_MODE_NO_TCF = 0x10,
463 /*! No fill bits means do not insert fill bits, even if the T.30 messages request
464 them. */
465 T30_IAF_MODE_NO_FILL_BITS = 0x20,
466 /*! No indicators means do not send indicator messages when using T.38. */
467 T30_IAF_MODE_NO_INDICATORS = 0x40,
468 /*! Use relaxed timers for T.38. This is appropriate when using TCP/TPKT for T.38,
469 as there is no point in anything but a long backstop timeout in such a mode. */
470 T30_IAF_MODE_RELAXED_TIMERS = 0x80
471};
472
473 typedef struct
474{
475 /*! \brief The identifier string (CSI, TSI, CIG). */
476 char ident[T30_MAX_IDENT_LEN + 1];
477 /*! \brief The sub-address string (SUB). */
478 char sub_address[T30_MAX_IDENT_LEN + 1];
479 /*! \brief The selective polling sub-address (SEP). */
480 char selective_polling_address[T30_MAX_IDENT_LEN + 1];
481 /*! \brief The polled sub-address (PSA). */
482 char polled_sub_address[T30_MAX_IDENT_LEN + 1];
483 /*! \brief The sender identification (SID). */
484 char sender_ident[T30_MAX_IDENT_LEN + 1];
485 /*! \brief The password (PWD). */
486 char password[T30_MAX_IDENT_LEN + 1];
487 /*! \brief Non-standard facilities (NSF). */
488 uint8_t *nsf;
489 size_t nsf_len;
490 /*! \brief Non-standard facilities command (NSC). */
491 uint8_t *nsc;
492 size_t nsc_len;
493 /*! \brief Non-standard facilities set-up (NSS). */
494 uint8_t *nss;
495 size_t nss_len;
496 /*! \brief Transmitting subscriber internet address (TSA). */
497 int tsa_type;
498 char *tsa;
499 size_t tsa_len;
500 /*! \brief Internet routing address (IRA). */
501 int ira_type;
502 char *ira;
503 size_t ira_len;
504 /*! \brief Calling subscriber internet address (CIA). */
505 int cia_type;
506 char *cia;
507 size_t cia_len;
508 /*! \brief Internet selective polling address (ISP). */
509 int isp_type;
510 char *isp;
511 size_t isp_len;
512 /*! \brief Called subscriber internet address (CSA). */
513 int csa_type;
514 char *csa;
515 size_t csa_len;
516} t30_exchanged_info_t;
517
518 typedef struct
519{
520 /*! \brief The current bit rate for image transfer. */
521 int bit_rate;
522 /*! \brief TRUE if error correcting mode is used. */
523 int error_correcting_mode;
524 /*! \brief The number of pages sent so far. */
525 int pages_tx;
526 /*! \brief The number of pages received so far. */
527 int pages_rx;
528 /*! \brief The number of pages in the file (<0 if not known). */
529 int pages_in_file;
530 /*! \brief The horizontal column-to-column resolution of the most recent page, in pixels per metre */
531 int x_resolution;
532 /*! \brief The vertical row-to-row resolution of the most recent page, in pixels per metre */
533 int y_resolution;
534 /*! \brief The number of horizontal pixels in the most recent page. */
535 int width;
536 /*! \brief The number of vertical pixels in the most recent page. */
537 int length;
538 /*! \brief The size of the image, in bytes */
539 int image_size;
540 /*! \brief The type of compression used between the FAX machines */
541 int encoding;
542 /*! \brief The number of bad pixel rows in the most recent page. */
543 int bad_rows;
544 /*! \brief The largest number of bad pixel rows in a block in the most recent page. */
545 int longest_bad_row_run;
546 /*! \brief The number of HDLC frame retries, if error correcting mode is used. */
547 int error_correcting_mode_retries;
548 /*! \brief Current status. */
549 int current_status;
550#if 0
551 /*! \brief The number of RTP events in this call. */
552 int rtp_events;
553 /*! \brief The number of RTN events in this call. */
554 int rtn_events;
555#endif
556} t30_stats_t;
557
558#if defined(__cplusplus)
559 extern "C"
560{
561#endif
562
563/*! Initialise a T.30 context.
564 \brief Initialise a T.30 context.
565 \param s The T.30 context.
566 \param calling_party TRUE if the context is for a calling party. FALSE if the
567 context is for an answering party.
568 \param set_rx_type_handler
569 \param set_rx_type_user_data
570 \param set_tx_type_handler
571 \param set_tx_type_user_data
572 \param send_hdlc_handler
573 \param send_hdlc_user_data
574 \return A pointer to the context, or NULL if there was a problem. */
575SPAN_DECLARE(t30_state_t *) t30_init(t30_state_t *s,
576 int calling_party,
577 t30_set_handler_t *set_rx_type_handler,
578 void *set_rx_type_user_data,
579 t30_set_handler_t *set_tx_type_handler,
580 void *set_tx_type_user_data,
581 t30_send_hdlc_handler_t *send_hdlc_handler,
582 void *send_hdlc_user_data);
583
584/*! Release a T.30 context.
585 \brief Release a T.30 context.
586 \param s The T.30 context.
587 \return 0 for OK, else -1. */
588SPAN_DECLARE(int) t30_release(t30_state_t *s);
589
590/*! Free a T.30 context.
591 \brief Free a T.30 context.
592 \param s The T.30 context.
593 \return 0 for OK, else -1. */
594SPAN_DECLARE(int) t30_free(t30_state_t *s);
595
596/*! Restart a T.30 context.
597 \brief Restart a T.30 context.
598 \param s The T.30 context.
599 \return 0 for OK, else -1. */
600SPAN_DECLARE(int) t30_restart(t30_state_t *s);
601
602/*! Check if a T.30 call is still active. This may be used to regularly poll
603 if the job has finished.
604 \brief Check if a T.30 call is still active.
605 \param s The T.30 context.
606 \return TRUE for call still active, or FALSE for call completed. */
607SPAN_DECLARE(int) t30_call_active(t30_state_t *s);
608
609/*! Cleanup a T.30 context if the call terminates.
610 \brief Cleanup a T.30 context if the call terminates.
611 \param s The T.30 context. */
612SPAN_DECLARE(void) t30_terminate(t30_state_t *s);
613
614/*! Inform the T.30 engine of a status change in the front end (end of tx, rx signal change, etc.).
615 \brief Inform the T.30 engine of a status change in the front end (end of tx, rx signal change, etc.).
616 \param user_data The T.30 context.
617 \param status The type of status change which occured. */
618SPAN_DECLARE(void) t30_front_end_status(void *user_data, int status);
619
620/*! Get a bit of received non-ECM image data.
621 \brief Get a bit of received non-ECM image data.
622 \param user_data An opaque pointer, which must point to the T.30 context.
623 \return The next bit to transmit. */
624 SPAN_DECLARE_NONSTD(int) t30_non_ecm_get_bit(void *user_data);
625
626/*! Get a byte of received non-ECM image data.
627 \brief Get a byte of received non-ECM image data.
628 \param user_data An opaque pointer, which must point to the T.30 context.
629 \return The next byte to transmit. */
630SPAN_DECLARE(int) t30_non_ecm_get_byte(void *user_data);
631
632/*! Get a chunk of received non-ECM image data.
633 \brief Get a bit of received non-ECM image data.
634 \param user_data An opaque pointer, which must point to the T.30 context.
635 \param buf The buffer to contain the data.
636 \param max_len The maximum length of the chunk.
637 \return The actual length of the chunk. */
638SPAN_DECLARE(int) t30_non_ecm_get_chunk(void *user_data, uint8_t buf[], int max_len);
639
640/*! Process a bit of received non-ECM image data.
641 \brief Process a bit of received non-ECM image data
642 \param user_data An opaque pointer, which must point to the T.30 context.
643 \param bit The received bit. */
644 SPAN_DECLARE_NONSTD(void) t30_non_ecm_put_bit(void *user_data, int bit);
645
646/*! Process a byte of received non-ECM image data.
647 \brief Process a byte of received non-ECM image data
648 \param user_data An opaque pointer, which must point to the T.30 context.
649 \param byte The received byte. */
650SPAN_DECLARE(void) t30_non_ecm_put_byte(void *user_data, int byte);
651
652/*! Process a chunk of received non-ECM image data.
653 \brief Process a chunk of received non-ECM image data
654 \param user_data An opaque pointer, which must point to the T.30 context.
655 \param buf The buffer containing the received data.
656 \param len The length of the data in buf. */
657SPAN_DECLARE(void) t30_non_ecm_put_chunk(void *user_data, const uint8_t buf[], int len);
658
659/*! Process a received HDLC frame.
660 \brief Process a received HDLC frame.
661 \param user_data The T.30 context.
662 \param msg The HDLC message.
663 \param len The length of the message, in octets.
664 \param ok TRUE if the frame was received without error. */
665 SPAN_DECLARE_NONSTD(void) t30_hdlc_accept(void *user_data, const uint8_t msg[], int len, int ok);
666
667/*! Report the passage of time to the T.30 engine.
668 \brief Report the passage of time to the T.30 engine.
669 \param s The T.30 context.
670 \param samples The time change in 1/8000th second steps. */
671SPAN_DECLARE(void) t30_timer_update(t30_state_t *s, int samples);
672
673/*! Get the current transfer statistics for the file being sent or received.
674 \brief Get the current transfer statistics.
675 \param s The T.30 context.
676 \param t A pointer to a buffer for the statistics. */
677SPAN_DECLARE(void) t30_get_transfer_statistics(t30_state_t *s, t30_stats_t *t);
678
679/*! Request a local interrupt of FAX exchange.
680 \brief Request a local interrupt of FAX exchange.
681 \param s The T.30 context.
682 \param state TRUE to enable interrupt request, else FALSE. */
683SPAN_DECLARE(void) t30_local_interrupt_request(t30_state_t *s, int state);
684
685/*! Allow remote interrupts of FAX exchange.
686 \brief Allow remote interrupts of FAX exchange.
687 \param s The T.30 context.
688 \param state TRUE to allow interruptd, else FALSE. */
689SPAN_DECLARE(void) t30_remote_interrupts_allowed(t30_state_t *s, int state);
690
691#if defined(__cplusplus)
692}
693#endif
694
695#endif
696/*- End of file ------------------------------------------------------------*/
t30_exchanged_info_t
Definition t30.h:474
t30_exchanged_info_t::nsf
uint8_t * nsf
Non-standard facilities (NSF).
Definition t30.h:488
t30_exchanged_info_t::ira_type
int ira_type
Internet routing address (IRA).
Definition t30.h:501
t30_exchanged_info_t::isp_type
int isp_type
Internet selective polling address (ISP).
Definition t30.h:509
t30_exchanged_info_t::nsc
uint8_t * nsc
Non-standard facilities command (NSC).
Definition t30.h:491
t30_exchanged_info_t::cia_type
int cia_type
Calling subscriber internet address (CIA).
Definition t30.h:505
t30_exchanged_info_t::polled_sub_address
char polled_sub_address[20+1]
The polled sub-address (PSA).
Definition t30.h:482
t30_exchanged_info_t::ident
char ident[20+1]
The identifier string (CSI, TSI, CIG).
Definition t30.h:476
t30_exchanged_info_t::tsa_type
int tsa_type
Transmitting subscriber internet address (TSA).
Definition t30.h:497
t30_exchanged_info_t::sub_address
char sub_address[20+1]
The sub-address string (SUB).
Definition t30.h:478
t30_exchanged_info_t::nss
uint8_t * nss
Non-standard facilities set-up (NSS).
Definition t30.h:494
t30_exchanged_info_t::selective_polling_address
char selective_polling_address[20+1]
The selective polling sub-address (SEP).
Definition t30.h:480
t30_exchanged_info_t::password
char password[20+1]
The password (PWD).
Definition t30.h:486
t30_exchanged_info_t::csa_type
int csa_type
Called subscriber internet address (CSA).
Definition t30.h:513
t30_exchanged_info_t::sender_ident
char sender_ident[20+1]
The sender identification (SID).
Definition t30.h:484
t30_state_s
Definition private/t30.h:36
t30_state_s::send_hdlc_handler
t30_send_hdlc_handler_t * send_hdlc_handler
The transmitted HDLC frame handler.
Definition private/t30.h:132
t30_state_s::rtn_events
int rtn_events
The number of RTN events.
Definition private/t30.h:303
t30_state_s::short_train
int short_train
True if the short training sequence should be used.
Definition private/t30.h:166
t30_state_s::set_tx_type_user_data
void * set_tx_type_user_data
An opaque pointer passed to the handler for changes to the transmit mode.
Definition private/t30.h:129
t30_state_s::rtp_events
int rtp_events
The number of RTP events.
Definition private/t30.h:301
t30_state_s::set_rx_type_handler
t30_set_handler_t * set_rx_type_handler
The handler for changes to the receive mode.
Definition private/t30.h:123
t30_state_s::calling_party
int calling_party
True if behaving as the calling party.
Definition private/t30.h:47
t30_state_s::send_hdlc_user_data
void * send_hdlc_user_data
An opaque pointer passed to the transmitted HDLC frame handler.
Definition private/t30.h:134
t30_state_s::set_rx_type_user_data
void * set_rx_type_user_data
An opaque pointer passed to the handler for changes to the receive mode.
Definition private/t30.h:125
t30_state_s::set_tx_type_handler
t30_set_handler_t * set_tx_type_handler
The handler for changes to the transmit mode.
Definition private/t30.h:127
t30_stats_t
Definition t30.h:519
t30_stats_t::error_correcting_mode_retries
int error_correcting_mode_retries
The number of HDLC frame retries, if error correcting mode is used.
Definition t30.h:547
t30_stats_t::bit_rate
int bit_rate
The current bit rate for image transfer.
Definition t30.h:521
t30_stats_t::image_size
int image_size
The size of the image, in bytes.
Definition t30.h:539
t30_stats_t::current_status
int current_status
Current status.
Definition t30.h:549
t30_stats_t::width
int width
The number of horizontal pixels in the most recent page.
Definition t30.h:535
t30_stats_t::error_correcting_mode
int error_correcting_mode
TRUE if error correcting mode is used.
Definition t30.h:523
t30_stats_t::longest_bad_row_run
int longest_bad_row_run
The largest number of bad pixel rows in a block in the most recent page.
Definition t30.h:545
t30_stats_t::y_resolution
int y_resolution
The vertical row-to-row resolution of the most recent page, in pixels per metre.
Definition t30.h:533
t30_stats_t::length
int length
The number of vertical pixels in the most recent page.
Definition t30.h:537
t30_stats_t::pages_in_file
int pages_in_file
The number of pages in the file (<0 if not known).
Definition t30.h:529
t30_stats_t::pages_tx
int pages_tx
The number of pages sent so far.
Definition t30.h:525
t30_stats_t::encoding
int encoding
The type of compression used between the FAX machines.
Definition t30.h:541
t30_stats_t::x_resolution
int x_resolution
The horizontal column-to-column resolution of the most recent page, in pixels per metre.
Definition t30.h:531
t30_stats_t::bad_rows
int bad_rows
The number of bad pixel rows in the most recent page.
Definition t30.h:543
t30_stats_t::pages_rx
int pages_rx
The number of pages received so far.
Definition t30.h:527
t30_remote_interrupts_allowed
void t30_remote_interrupts_allowed(t30_state_t *s, int state)
Allow remote interrupts of FAX exchange.
Definition t30.c:6281
t30_terminate
void t30_terminate(t30_state_t *s)
Cleanup a T.30 context if the call terminates.
Definition t30.c:6196
t30_init
t30_state_t * t30_init(t30_state_t *s, int calling_party, t30_set_handler_t *set_rx_type_handler, void *set_rx_type_user_data, t30_set_handler_t *set_tx_type_handler, void *set_tx_type_user_data, t30_send_hdlc_handler_t *send_hdlc_handler, void *send_hdlc_user_data)
Initialise a T.30 context.
Definition t30.c:6327
t30_timer_update
void t30_timer_update(t30_state_t *s, int samples)
Report the passage of time to the T.30 engine.
Definition t30.c:6127
t30_release
int t30_release(t30_state_t *s)
Release a T.30 context.
Definition t30.c:6368
t30_non_ecm_get_byte
int t30_non_ecm_get_byte(void *user_data)
Get a byte of received non-ECM image data.
Definition t30.c:5573
t30_front_end_status
void t30_front_end_status(void *user_data, int status)
Inform the T.30 engine of a status change in the front end (end of tx, rx signal change,...
Definition t30.c:5833
t30_non_ecm_put_byte
void t30_non_ecm_put_byte(void *user_data, int byte)
Process a byte of received non-ECM image data.
Definition t30.c:5457
t30_call_active
int t30_call_active(t30_state_t *s)
Check if a T.30 call is still active.
Definition t30.c:6385
T30_SUPPORT_POLLED_SUB_ADDRESSING
@ T30_SUPPORT_POLLED_SUB_ADDRESSING
Definition t30.h:431
T30_SUPPORT_INTERNET_ROUTING_ADDRESS
@ T30_SUPPORT_INTERNET_ROUTING_ADDRESS
Definition t30.h:439
T30_SUPPORT_MULTIPLE_SELECTIVE_POLLING
@ T30_SUPPORT_MULTIPLE_SELECTIVE_POLLING
Definition t30.h:433
T30_SUPPORT_TRANSMITTING_SUBSCRIBER_INTERNET_ADDRESS
@ T30_SUPPORT_TRANSMITTING_SUBSCRIBER_INTERNET_ADDRESS
Definition t30.h:437
T30_SUPPORT_IDENTIFICATION
@ T30_SUPPORT_IDENTIFICATION
Definition t30.h:427
T30_SUPPORT_CALLING_SUBSCRIBER_INTERNET_ADDRESS
@ T30_SUPPORT_CALLING_SUBSCRIBER_INTERNET_ADDRESS
Definition t30.h:441
T30_SUPPORT_COMMAND_REPEAT
@ T30_SUPPORT_COMMAND_REPEAT
Definition t30.h:449
T30_SUPPORT_SELECTIVE_POLLING
@ T30_SUPPORT_SELECTIVE_POLLING
Definition t30.h:429
T30_SUPPORT_SUB_ADDRESSING
@ T30_SUPPORT_SUB_ADDRESSING
Definition t30.h:435
T30_SUPPORT_FIELD_NOT_VALID
@ T30_SUPPORT_FIELD_NOT_VALID
Definition t30.h:447
T30_SUPPORT_CALLED_SUBSCRIBER_INTERNET_ADDRESS
@ T30_SUPPORT_CALLED_SUBSCRIBER_INTERNET_ADDRESS
Definition t30.h:445
T30_SUPPORT_INTERNET_SELECTIVE_POLLING_ADDRESS
@ T30_SUPPORT_INTERNET_SELECTIVE_POLLING_ADDRESS
Definition t30.h:443
t30_phase_e_handler_t
void t30_phase_e_handler_t(t30_state_t *s, void *user_data, int completion_code)
T.30 phase E callback handler.
Definition t30.h:180
T30_SUPPORT_T4_1D_COMPRESSION
@ T30_SUPPORT_T4_1D_COMPRESSION
Definition t30.h:358
T30_SUPPORT_T4_2D_COMPRESSION
@ T30_SUPPORT_T4_2D_COMPRESSION
Definition t30.h:360
T30_SUPPORT_T45_COMPRESSION
@ T30_SUPPORT_T45_COMPRESSION
Definition t30.h:370
T30_SUPPORT_T6_COMPRESSION
@ T30_SUPPORT_T6_COMPRESSION
Definition t30.h:362
T30_SUPPORT_T81_COMPRESSION
@ T30_SUPPORT_T81_COMPRESSION
Definition t30.h:372
T30_SUPPORT_T85_COMPRESSION
@ T30_SUPPORT_T85_COMPRESSION
Definition t30.h:364
T30_SUPPORT_T85_L0_COMPRESSION
@ T30_SUPPORT_T85_L0_COMPRESSION
Definition t30.h:366
T30_SUPPORT_T88_COMPRESSION
@ T30_SUPPORT_T88_COMPRESSION
Definition t30.h:376
T30_SUPPORT_SYCC_T81_COMPRESSION
@ T30_SUPPORT_SYCC_T81_COMPRESSION
Definition t30.h:374
T30_SUPPORT_T43_COMPRESSION
@ T30_SUPPORT_T43_COMPRESSION
Definition t30.h:368
T30_SUPPORT_NO_COMPRESSION
@ T30_SUPPORT_NO_COMPRESSION
Definition t30.h:356
T30_MAX_IDENT_LEN
#define T30_MAX_IDENT_LEN
Definition t30.h:144
T30_SUPPORT_V34HDX
@ T30_SUPPORT_V34HDX
Definition t30.h:348
T30_SUPPORT_IAF
@ T30_SUPPORT_IAF
Definition t30.h:350
T30_SUPPORT_V27TER
@ T30_SUPPORT_V27TER
Definition t30.h:342
T30_SUPPORT_V17
@ T30_SUPPORT_V17
Definition t30.h:346
T30_SUPPORT_V29
@ T30_SUPPORT_V29
Definition t30.h:344
T30_SUPPORT_600_600_RESOLUTION
@ T30_SUPPORT_600_600_RESOLUTION
Definition t30.h:400
T30_SUPPORT_400_800_RESOLUTION
@ T30_SUPPORT_400_800_RESOLUTION
Definition t30.h:406
T30_SUPPORT_300_600_RESOLUTION
@ T30_SUPPORT_300_600_RESOLUTION
Definition t30.h:404
T30_SUPPORT_400_400_RESOLUTION
@ T30_SUPPORT_400_400_RESOLUTION
Definition t30.h:398
T30_SUPPORT_SUPERFINE_RESOLUTION
@ T30_SUPPORT_SUPERFINE_RESOLUTION
Definition t30.h:386
T30_SUPPORT_1200_1200_RESOLUTION
@ T30_SUPPORT_1200_1200_RESOLUTION
Definition t30.h:402
T30_SUPPORT_300_300_RESOLUTION
@ T30_SUPPORT_300_300_RESOLUTION
Definition t30.h:396
T30_SUPPORT_R8_RESOLUTION
@ T30_SUPPORT_R8_RESOLUTION
Definition t30.h:391
T30_SUPPORT_R16_RESOLUTION
@ T30_SUPPORT_R16_RESOLUTION
Definition t30.h:393
T30_SUPPORT_600_1200_RESOLUTION
@ T30_SUPPORT_600_1200_RESOLUTION
Definition t30.h:408
T30_SUPPORT_STANDARD_RESOLUTION
@ T30_SUPPORT_STANDARD_RESOLUTION
Definition t30.h:382
T30_SUPPORT_FINE_RESOLUTION
@ T30_SUPPORT_FINE_RESOLUTION
Definition t30.h:384
T30_SUPPORT_R4_RESOLUTION
@ T30_SUPPORT_R4_RESOLUTION
Definition t30.h:389
t30_phase_d_handler_t
int t30_phase_d_handler_t(t30_state_t *s, void *user_data, int result)
T.30 phase D callback handler.
Definition t30.h:171
t30_real_time_frame_handler_t
void t30_real_time_frame_handler_t(t30_state_t *s, void *user_data, int direction, const uint8_t msg[], int len)
T.30 real time frame handler.
Definition t30.h:191
t30_set_handler_t
void t30_set_handler_t(void *user_data, int type, int bit_rate, int short_train, int use_hdlc)
T.30 set a receive or transmit type handler.
Definition t30.h:215
T30_ERR_RX_T2EXPDCN
@ T30_ERR_RX_T2EXPDCN
Definition t30.h:266
T30_ERR_NOSIZESUPPORT
@ T30_ERR_NOSIZESUPPORT
Definition t30.h:245
T30_ERR_TX_PHBDEAD
@ T30_ERR_TX_PHBDEAD
Definition t30.h:255
T30_ERR_IRA_UNACCEPTABLE
@ T30_ERR_IRA_UNACCEPTABLE
Definition t30.h:301
T30_ERR_TX_INCAPABLE
@ T30_ERR_TX_INCAPABLE
Definition t30.h:243
T30_ERR_T0_EXPIRED
@ T30_ERR_T0_EXPIRED
Definition t30.h:235
T30_ERR_RX_NOFAX
@ T30_ERR_RX_NOFAX
Definition t30.h:265
T30_ERR_ISP_UNACCEPTABLE
@ T30_ERR_ISP_UNACCEPTABLE
Definition t30.h:303
T30_ERR_CSA_UNACCEPTABLE
@ T30_ERR_CSA_UNACCEPTABLE
Definition t30.h:304
T30_ERR_CEDTONE
@ T30_ERR_CEDTONE
Definition t30.h:234
T30_ERR_RX_NOEOL
@ T30_ERR_RX_NOEOL
Definition t30.h:264
T30_ERR_NOPOLL
@ T30_ERR_NOPOLL
Definition t30.h:293
T30_ERR_PWD_UNACCEPTABLE
@ T30_ERR_PWD_UNACCEPTABLE
Definition t30.h:299
T30_ERR_RX_DCNNORTN
@ T30_ERR_RX_DCNNORTN
Definition t30.h:277
T30_ERR_SEP_UNACCEPTABLE
@ T30_ERR_SEP_UNACCEPTABLE
Definition t30.h:296
T30_ERR_INCOMPATIBLE
@ T30_ERR_INCOMPATIBLE
Definition t30.h:241
T30_ERR_TX_T5EXP
@ T30_ERR_TX_T5EXP
Definition t30.h:257
T30_ERR_NOPAGE
@ T30_ERR_NOPAGE
Definition t30.h:281
T30_ERR_RETRYDCN
@ T30_ERR_RETRYDCN
Definition t30.h:289
T30_ERR_RX_DCNPHD
@ T30_ERR_RX_DCNPHD
Definition t30.h:275
T30_ERR_BADTIFF
@ T30_ERR_BADTIFF
Definition t30.h:282
T30_ERR_FILEERROR
@ T30_ERR_FILEERROR
Definition t30.h:280
T30_ERR_NOMEM
@ T30_ERR_NOMEM
Definition t30.h:286
T30_ERR_BADTIFFHDR
@ T30_ERR_BADTIFFHDR
Definition t30.h:285
T30_ERR_TSA_UNACCEPTABLE
@ T30_ERR_TSA_UNACCEPTABLE
Definition t30.h:300
T30_ERR_BADTAG
@ T30_ERR_BADTAG
Definition t30.h:284
T30_ERR_RX_DCNFAX
@ T30_ERR_RX_DCNFAX
Definition t30.h:274
T30_ERR_UNEXPECTED
@ T30_ERR_UNEXPECTED
Definition t30.h:246
T30_ERR_SUB_UNACCEPTABLE
@ T30_ERR_SUB_UNACCEPTABLE
Definition t30.h:295
T30_ERR_HDLC_CARRIER
@ T30_ERR_HDLC_CARRIER
Definition t30.h:238
T30_ERR_RX_T2EXPD
@ T30_ERR_RX_T2EXPD
Definition t30.h:267
T30_ERR_T1_EXPIRED
@ T30_ERR_T1_EXPIRED
Definition t30.h:236
T30_ERR_RX_GOTDCS
@ T30_ERR_RX_GOTDCS
Definition t30.h:261
T30_ERR_TX_PHDDEAD
@ T30_ERR_TX_PHDDEAD
Definition t30.h:256
T30_ERR_RX_T2EXPFAX
@ T30_ERR_RX_T2EXPFAX
Definition t30.h:268
T30_ERR_RX_DCNWHY
@ T30_ERR_RX_DCNWHY
Definition t30.h:272
T30_ERR_NORESSUPPORT
@ T30_ERR_NORESSUPPORT
Definition t30.h:244
T30_ERR_TX_NODIS
@ T30_ERR_TX_NODIS
Definition t30.h:254
T30_ERR_IDENT_UNACCEPTABLE
@ T30_ERR_IDENT_UNACCEPTABLE
Definition t30.h:294
T30_ERR_RX_DCNDATA
@ T30_ERR_RX_DCNDATA
Definition t30.h:273
T30_ERR_RX_T2EXPRR
@ T30_ERR_RX_T2EXPRR
Definition t30.h:270
T30_ERR_CANNOT_TRAIN
@ T30_ERR_CANNOT_TRAIN
Definition t30.h:239
T30_ERR_TX_BADPG
@ T30_ERR_TX_BADPG
Definition t30.h:250
T30_ERR_T3_EXPIRED
@ T30_ERR_T3_EXPIRED
Definition t30.h:237
T30_ERR_CALLDROPPED
@ T30_ERR_CALLDROPPED
Definition t30.h:290
T30_ERR_SID_UNACCEPTABLE
@ T30_ERR_SID_UNACCEPTABLE
Definition t30.h:298
T30_ERR_RX_NOCARRIER
@ T30_ERR_RX_NOCARRIER
Definition t30.h:263
T30_ERR_TX_BADDCS
@ T30_ERR_TX_BADDCS
Definition t30.h:249
T30_ERR_RX_ECMPHD
@ T30_ERR_RX_ECMPHD
Definition t30.h:260
T30_ERR_TX_GOTDCN
@ T30_ERR_TX_GOTDCN
Definition t30.h:252
T30_ERR_BADPAGE
@ T30_ERR_BADPAGE
Definition t30.h:283
T30_ERR_OPER_INT_FAIL
@ T30_ERR_OPER_INT_FAIL
Definition t30.h:240
T30_ERR_RX_DCNRRD
@ T30_ERR_RX_DCNRRD
Definition t30.h:276
T30_ERR_RX_T2EXPMPS
@ T30_ERR_RX_T2EXPMPS
Definition t30.h:269
T30_ERR_TX_INVALRSP
@ T30_ERR_TX_INVALRSP
Definition t30.h:253
T30_ERR_TX_ECMPHD
@ T30_ERR_TX_ECMPHD
Definition t30.h:251
T30_ERR_RX_T2EXP
@ T30_ERR_RX_T2EXP
Definition t30.h:271
T30_ERR_RX_INVALCMD
@ T30_ERR_RX_INVALCMD
Definition t30.h:262
T30_ERR_PSA_UNACCEPTABLE
@ T30_ERR_PSA_UNACCEPTABLE
Definition t30.h:297
T30_ERR_CIA_UNACCEPTABLE
@ T30_ERR_CIA_UNACCEPTABLE
Definition t30.h:302
T30_ERR_RX_INCAPABLE
@ T30_ERR_RX_INCAPABLE
Definition t30.h:242
t30_get_transfer_statistics
void t30_get_transfer_statistics(t30_state_t *s, t30_stats_t *t)
Get the current transfer statistics.
Definition t30.c:6229
T30_IAF_MODE_NO_FILL_BITS
@ T30_IAF_MODE_NO_FILL_BITS
Definition t30.h:465
T30_IAF_MODE_NO_INDICATORS
@ T30_IAF_MODE_NO_INDICATORS
Definition t30.h:467
T30_IAF_MODE_CONTINUOUS_FLOW
@ T30_IAF_MODE_CONTINUOUS_FLOW
Definition t30.h:459
T30_IAF_MODE_RELAXED_TIMERS
@ T30_IAF_MODE_RELAXED_TIMERS
Definition t30.h:470
T30_IAF_MODE_NO_TCF
@ T30_IAF_MODE_NO_TCF
Definition t30.h:462
SPAN_DECLARE_NONSTD
SPAN_DECLARE_NONSTD(void) t30_non_ecm_put_bit(void *user_data
Process a bit of received non-ECM image data.
t30_send_hdlc_handler_t
void t30_send_hdlc_handler_t(void *user_data, const uint8_t msg[], int len)
T.30 send HDLC handler.
Definition t30.h:224
t30_non_ecm_put_chunk
void t30_non_ecm_put_chunk(void *user_data, const uint8_t buf[], int len)
Process a chunk of received non-ECM image data.
Definition t30.c:5498
t30_document_handler_t
int t30_document_handler_t(t30_state_t *s, void *user_data, int status)
T.30 document handler.
Definition t30.h:204
t30_free
int t30_free(t30_state_t *s)
Free a T.30 context.
Definition t30.c:6377
T30_FRONT_END_RECEIVE_COMPLETE
@ T30_FRONT_END_RECEIVE_COMPLETE
Definition t30.h:332
t30_phase_b_handler_t
int t30_phase_b_handler_t(t30_state_t *s, void *user_data, int result)
T.30 phase B callback handler.
Definition t30.h:161
t30_local_interrupt_request
void t30_local_interrupt_request(t30_state_t *s, int state)
Request a local interrupt of FAX exchange.
Definition t30.c:6269
t30_restart
int t30_restart(t30_state_t *s)
Restart a T.30 context.
Definition t30.c:6287
t30_non_ecm_get_chunk
int t30_non_ecm_get_chunk(void *user_data, uint8_t buf[], int max_len)
Get a bit of received non-ECM image data.
Definition t30.c:5608